library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity ER_Project is port (
  clk : in std_logic;
  pwm : out std_logic_vector(1 downto 0)
    );
end entity;

architecture Movemotor of ER_Project is

component diviseur is port (
	clk : in std_logic;
	eno : out std_logic
--	q : out std_logic_vector(23 downto 0)
	);
end component;

component cmpt_hzt is port (
	clk, en : in std_logic;
	eno : out std_logic;
	s_hzt : out std_logic_vector(7 downto 0)
	);
end component;

component cmpt_vtc is port (
	clk, en : in std_logic;
	s_vtc : out std_logic_vector(7 downto 0)
	);
end component;

 signal timer : natural range 0 to 3900 := 0;
 signal eno : std_logic;
 signal s_cmpt8 : std_logic_vector(7 downto 0);
 signal s_eno, s_eno1 : std_logic;
 signal ref1 : std_logic_vector(7 downto 0);
 signal ref2 : std_logic_vector(7 downto 0);
begin 

div : diviseur port map (
	clk => clk, eno => s_eno
	);
cmpt1 : cmpt_hzt port map (
	clk => clk, en => s_eno, eno => s_eno1, s_hzt => ref1
	);
cmpt2 : cmpt_vtc port map (
	clk => clk, en => s_eno1, s_vtc => ref2
	);

 -- realisation 78 us
 process(clk)
  begin
    if rising_edge(clk) then
      if timer = 0 then
        timer <= 3900;
        eno <= '1';
      else
        timer <= timer - 1;
		  eno <='0';
      end if;
    end if;
  end process;
 
  cmpt8:process(clk) begin
     if rising_edge(clk) then
	    if eno = '1' then
		   s_cmpt8 <= s_cmpt8 + 1;
		 end if;
	  end if;
	end process; 

--comparaison svm hrz
 process(s_cmpt8)
  begin	
	if (s_cmpt8 < ref1) then
		pwm(0) <= '1';
	else
		pwm(0) <= '0';
	end if;
  end process;
  
  
  --comparaison svm vtc
 process(s_cmpt8)
  begin	
	if (s_cmpt8 < ref2) then
		pwm(1) <= '1';
	else
		pwm(1) <= '0';
	end if;
  end process;
  
end Movemotor;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
entity diviseur is port (
	clk : in std_logic;
	eno : out std_logic
--	q : out std_logic_vector(23 downto 0)
	);
end entity diviseur;

architecture arch of diviseur is
signal cmpt : std_logic_vector(23 downto 0);
begin
  process (clk) begin
    if rising_edge(clk) then
	   cmpt <= cmpt+1;
	 end if;
  end process;
  eno <= '1' when cmpt = x"FFFFFF" else
         '0';
end arch;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
entity cmpt_hzt is port (
	clk, en : in std_logic;
	eno : out std_logic;
	s_hzt : out std_logic_vector(7 downto 0)
	);
end entity cmpt_hzt;

architecture arch of cmpt_hzt is
  signal cmpt : std_logic_vector(7 downto 0) := x"0A";
begin
  process (clk) begin
    if rising_edge(clk) then
	   if en='1' then
	     if cmpt < x"1F" then
		    cmpt <= cmpt+1;
		  else
		    cmpt <= x"08";
		  end if;
		end if;
	 end if;
  end process;
  eno <= '1' when cmpt = x"1F" else
         '0';
  s_hzt <= cmpt;
end arch;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
entity cmpt_vtc is port (
	clk, en : in std_logic;
	s_vtc : out std_logic_vector(7 downto 0)
	);
end entity;

architecture arch of cmpt_vtc is
  signal cmpt : std_logic_vector(7 downto 0) := x"0A";
begin
  process (clk) begin
    if rising_edge(clk) then
	   if en='1' then
	     if cmpt < x"14" then
		    cmpt <= cmpt+1;
		  else
		    cmpt <= x"0A";
		  end if;
		end if;
	 end if;
  end process;
  s_vtc <= cmpt;
end arch;